package com.mygdx.game;

import com.badlogic.gdx.ApplicationAdapter;
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Input;
import com.badlogic.gdx.graphics.GL20;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.BitmapFont;
import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;

public class MyGdxGame extends ApplicationAdapter {
	SpriteBatch batch;
	Texture ground;
	Sprite sprite01;
	Sprite sprite02;
	Sprite sprite;
	int w, h;
	BitmapFont font;
	int count;
	
	@Override
	public void create () {
		w = Gdx.graphics.getWidth();
		h = Gdx.graphics.getHeight();
		batch = new SpriteBatch();
		ground = new Texture("ground.jpg");
		sprite01 = new Sprite(new Texture("sprite01.png"));
		sprite01.setPosition(100, 100);
		sprite02 = new Sprite(new Texture("sprite02.png"));
		sprite02.setPosition(300, 200);
		sprite = sprite01;
		font = new BitmapFont(
				Gdx.files.internal("verdana.fnt"),
				Gdx.files.internal("verdana.png"), false);
		font.setColor(1, 1, 1, 1);
	}

	private void execute() {
		final int SPEED = 10;
		if (Gdx.input.isKeyPressed(Input.Keys.UP)) {
			sprite.setY(sprite.getY() + SPEED);
		} else if (Gdx.input.isKeyPressed(Input.Keys.DOWN)) {
			sprite.setY(sprite.getY() - SPEED);
		}
		if (Gdx.input.isKeyPressed(Input.Keys.LEFT)) {
			sprite.setX(sprite.getX() - SPEED);
		} else if (Gdx.input.isKeyPressed(Input.Keys.RIGHT)) {
			sprite.setX(sprite.getX() + SPEED);
		}
		if (Gdx.input.isKeyJustPressed(Input.Keys.TAB)) {
			sprite = (sprite == sprite01) ? sprite02 : sprite01;
			count++;
		}
		if (sprite.getX() < 0) {
			sprite.setX(0);
		}
		if (sprite.getX() > w - sprite.getWidth()) {
			sprite.setX(w - sprite.getWidth());
		}
		if (sprite.getY() < 0) {
			sprite.setY(0);
		}
		if (sprite.getY() > h - sprite.getHeight()) {
			sprite.setY(h - sprite.getHeight());
		}
	}

	@Override
	public void render () {
		execute();
		Gdx.gl.glClearColor(1, 0, 0, 1);
		Gdx.gl.glClear(GL20.GL_COLOR_BUFFER_BIT);
		batch.begin();
		batch.draw(ground, 0, 0);
		sprite01.draw(batch);
		sprite02.draw(batch);
		String pos01 = "Sprite01 (" + sprite01.getX() + ", " +
				sprite01.getY() + ") ";
		String pos02 = "Sprite02 (" + sprite02.getX() + ", " +
				sprite02.getY() + ")";
		font.draw(batch, pos01, 1, h - 1);
		font.draw(batch, pos02, 1, h - 51);
		String scount = "TAB: " + count;
		font.draw(batch, scount, 1, 50);
		batch.end();
	}
	
	@Override
	public void dispose () {
		batch.dispose();
		ground.dispose();
		sprite01.getTexture().dispose();
		sprite02.getTexture().dispose();
	}
}

